#!/usr/bin/env python

import qmf.console
import optparse

parser = optparse.OptionParser(usage="usage: %prog [options] ...",
                               description="Writes and reloads a deny or allow acl file.")
parser.add_option("-b", "--broker", default="localhost",
                  help="connect to specified BROKER (default %default)")
parser.add_option("-m", dest="mode", default="deny",
                  help="Which acl mode to load. Should be one of {deny|allow}")

opts, args = parser.parse_args()

print "mode is :", opts.mode

class ACLFile:
    def __init__(self):
        self.f = open('/tmp/policy.acl','w');
   
    def write(self,line):
        self.f.write(line)
    
    def close(self):
        self.f.close()

def write_deny_acl():
    aclf = ACLFile()
    aclf.write('acl allow anonymous all all\n')
    aclf.write('acl allow jack@QPID create queue\n')
    aclf.write('acl allow guest@QPID access exchange\n')
    aclf.write('acl allow guest@QPID access queue\n')
    aclf.write('acl allow guest@QPID publish all\n')
    for i in range(1000):
        aclf.write('acl allow bob' + str(i) + '@QPID publish all\n')
    aclf.write('acl deny all all')
    aclf.close()  

def write_allow_acl():
    aclf = ACLFile()
    aclf.write('acl deny henry@QPID all all\n') # to trigger transfer acl
    for i in range(1000):
        aclf.write('acl deny bob' + str(i) + '@QPID publish all\n') # to trigger transfer acl
    aclf.write('acl deny matt@QPID create queue\n')
    aclf.write('acl allow all all')
    aclf.close()  
      

qmf = qmf.console.Session()
qmf_broker = qmf.addBroker(opts.broker)
if opts.mode == "deny":
    write_deny_acl()
else:
    write_allow_acl()

acl = qmf.getObjects(_class="acl")[0]
result = acl.reloadACLFile()
print result.txt   

